<?php
/*
Plugin Name: Sync SugarCRM Users
Plugin URI: http://sukum.net/sync-sugarcrm-users/
Description: Sync SugarCRM Users To Wordpress and vice versa.
Version: 2.2
Author: sukum
Author URI: http://sukum.net/
License: GPLv2
*/

/*  Copyright 2012  sukum  (email : sukum@sukum.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define('SK_PLUGIN_NAME', 'Sync SugarCRM Users');

if (!class_exists("Sync_SugarCRM_Users")) {
class Sync_SugarCRM_Users {
  const USERS_LIMIT = 500;
  var $config_parameters_name = "sync_sugarcrm_users_parameters";
  var $sync_sugarcrm_users_parameters_ini = array(
      'crm_user_name' => '', 
      'crm_user_hash' => '', 
      'crm_url'       => '', 
      'crm_auto_create_user'  => 0, 
    );
  var $sync_sugarcrm_users_parameters;
  
  var $client  = null;
  var $session_id     = null;
  var $user_id     = '';

  function __construct() {
    $this->sync_sugarcrm_users_parameters = $this->getConfigParameters();
  }
  
  function init() {
    update_option($this->config_parameters_name, $this->sync_sugarcrm_users_parameters);
    //add_option($this->config_parameters_name, $this->sync_sugarcrm_users_parameters);
  }
  function deactivate() {
    update_option($this->config_parameters_name, $this->sync_sugarcrm_users_parameters_ini);
  }

  //Returns an array of config parameters
  function getConfigParameters() {
    $sync_sugarcrm_users_parameters = array(
      'crm_user_name' => '', 
      'crm_user_hash' => '', 
      'crm_url'       => '', 
      'crm_auto_create_user' => 0, 
    );
    $devOptions = get_option($this->config_parameters_name);
    if (!empty($devOptions)) {
      foreach ($devOptions as $key => $option)
        $sync_sugarcrm_users_parameters[$key] = $option;
    }				
    //update_option($this->config_parameters_name, $sync_sugarcrm_users_parameters);
    return $sync_sugarcrm_users_parameters;
  }
  
  function printViewSugarCRM() {
    $devOptions = $this->sync_sugarcrm_users_parameters;
    $messages  = array();
    $login_is_success  = false;
    
    // validation
    $ret_messages = $this->checkConfigFilled();
    if (!empty($ret_messages)) {
      $messages[] = $ret_messages;
    } else {
      $ret_messages = $this->soapInit();
      if (WP_DEBUG == true) {
        $messages       = array_merge($messages, $ret_messages);
      }
      $response = $this->client->__soapCall('seamless_login',array($this->session_id));
      if (empty($response)) {
        $messges[]  = 'Seamless login failed.';
      } else {
        $login_is_success = true;
      }
    }

?>
<div class=wrap>
<h2><?php echo SK_PLUGIN_NAME; ?> - SugarCRM</h2>
<?php    
    if (sizeof($messages) > 0) {
?>    
    <div class="updated"><p><strong><?php _e(implode('<br />', $messages), "Sync_SugarCRM_Users");?></strong></p></div>
<?php	
    }
    
    if ($login_is_success) {
?>
<iframe width="100%" height="100%" style="min-height: 1200px;" src="<?php echo $devOptions['crm_url']; ?>index.php?module=Home&action=index&MSID=<?php echo $this->session_id; ?>" ></iframe>
<?php
    }
?>
</div>
<?php
  
  }
  
  function syncPage() {
?>
<div class=wrap>
  <h2><?php echo SK_PLUGIN_NAME; ?></h2>
  <p><?php _e('This will sync users from SugarCRM to Wordpress and vice versa. <br />Only username and email address will be synced. <br />Default password of the user will be set as username. <br />Users with existing usernames or email will not be synced.', 'Sync_SugarCRM_Users') ?></p>
</div>    
<?php
  }

  //Prints out the config page
  function printConfigPage() {
    $devOptions = $this->sync_sugarcrm_users_parameters;
              
    if (isset($_POST['update_sync_sugarcrm_users_parameters'])) { 
      if (isset($_POST['crm_url'])) {
        if (substr($_POST['crm_url'], -1) != '/')
          $_POST['crm_url'] .= '/';
        $devOptions['crm_url'] = apply_filters('crm_url', $_POST['crm_url']);
      }	
      if (isset($_POST['crm_user_name'])) {
        $devOptions['crm_user_name'] = apply_filters('crm_user_name', $_POST['crm_user_name']);
      }	
      if (isset($_POST['crm_user_hash']) && !empty($_POST['crm_user_hash'])) {
        $devOptions['crm_user_hash'] = apply_filters('crm_user_hash', md5($_POST['crm_user_hash']));
      }	
      if (isset($_POST['crm_auto_create_user'])) {
        $devOptions['crm_auto_create_user'] = apply_filters('crm_auto_create_user', $_POST['crm_auto_create_user']);
      }	else {
        $devOptions['crm_auto_create_user'] = 0;
      }
      update_option($this->config_parameters_name, $devOptions);
						
?>
<div class="updated"><p><strong><?php _e("Config Changed.", "Sync_SugarCRM_Users");?></strong></p></div>
<?php	
    } 
?>
<div class=wrap>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h2><?php echo SK_PLUGIN_NAME; ?> - Config</h2>
<table class="form-table">
<tbody>
<tr valign="top">
<th scope="row"><label for="crm_url">CRM URL</label></th>
<td><input type="text" name="crm_url" id="crm_url" value="<?php _e(apply_filters('format_to_edit',$devOptions['crm_url']), 'Sync_SugarCRM_Users') ?>" class="regular-text" /> &nbsp;<span class="description"><?php _e('eg: http://example.com/crm/.', 'Sync_SugarCRM_Users') ?></span></td>
</th>
</tr>
<tr valign="top">
<th scope="row"><label for="crm_user_name">Username</label></th>
<td><input type="text" name="crm_user_name" id="crm_user_name" value="<?php _e(apply_filters('format_to_edit',$devOptions['crm_user_name']), 'Sync_SugarCRM_Users') ?>" class="regular-text" /></td>
</tr>
<tr>
<th scope="row"><label for="crm_user_hash">Password</label></th>
<td><input type="password" name="crm_user_hash" id="crm_user_hash" value="" class="regular-text" /></td>
</tr>
<tr>
<th scope="row"><label for="crm_auto_create_user">Auto sync user to SugarCRM</label></th>
<td><input type="checkbox" name="crm_auto_create_user" id="crm_auto_create_user" value="1" <?php if ($devOptions['crm_auto_create_user']) echo 'checked="checked"'; ?> /> &nbsp;<span class="description"><?php _e('If checked, when a user is created in Wordpress, the user will automatically be synced to SugarCRM', 'Sync_SugarCRM_Users') ?></span></td>
</tr>
</tbody>
</table>
<p class="submit">
<input type="submit" name="update_sync_sugarcrm_users_parameters" class="button-primary" value="<?php _e('Save Changes', 'Sync_SugarCRM_Users') ?>" /></p>
</form>
 </div>
<?php
	}//End function printConfigPage()

  //Prints out the Sync page
  function syncUsersToWPPage() {
    $devOptions = $this->sync_sugarcrm_users_parameters;
    $messages  = array();
    
    // validation
    $ret_messages = $this->checkConfigFilled();
    if (!empty($ret_messages)) {
      $messages[] = $ret_messages;
?>    
    <div class="updated"><p><strong><?php _e(implode('<br />', $messages), "Sync_SugarCRM_Users");?></strong></p></div>
<?php	
      return;
    }
    
    
    if (isset($_POST['sync_sugarcrm_users'])) { 
      $result = $this->syncUsersToWP();
      $response = $result['result'];
      foreach ($response as $user_obj) {
        $user_detail_str  = '';
        foreach ($user_obj->name_value_list as $key=>$user_field) {
          if (in_array($user_field->name, array('user_name', 'email1'))) {
            //$user_detail_str  .= $user_field->name.': '.$user_field->value.'&nbsp; |  &nbsp;';
            $user_detail_str  .= $user_field->value.'&nbsp; |  &nbsp;';
            switch ($user_field->name) {
              case 'user_name':
                $user_name  = $user_field->value;
                break;
              case 'email1':
                $user_email  = $user_field->value;
                break;
            }
          }
        }
        
        $user_id = username_exists( $user_name );
        if ( !$user_id and email_exists($user_email) == false ) {
          //$user_password = wp_generate_password( $length=12, $include_standard_special_chars=false );
          $user_password = $user_name;
          $user_id = wp_create_user( $user_name, $user_password, $user_email );
          if (!is_object($user_id)) {
            $user_detail_str .= 'User Created';
          } else {
            if ( is_wp_error($user_id) )
              $messages[] = $user_id->get_error_message();
          }
        } else {
          $user_detail_str .= 'User Exists';
        }
        if ($user_detail_str != '')
          $messages[] = $user_detail_str;

        //$messages[] = '<br />';
        if (sizeof($messages) > (Sync_SugarCRM_Users::USERS_LIMIT+1)) {
          $messages[Sync_SugarCRM_Users::USERS_LIMIT] = '...';
        }
        $messages = array_slice($messages, 0, (Sync_SugarCRM_Users::USERS_LIMIT+1));
      }
?>
<div class="updated"><p><strong><?php _e(implode('<br />', $messages), "Sync_SugarCRM_Users");?></strong></p></div>
<?php if (WP_DEBUG == true) { ?>
<div class="updated"><p><strong><?php _e(implode('<br />', $result['messages']), "Sync_SugarCRM_Users");?></strong></p></div>
<?php	
      }
    } 
?>
<div class=wrap>
  <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
    <h2><?php echo SK_PLUGIN_NAME; ?> - Sync to WordPress</h2>
    <p><?php _e('This will fetch users from SugarCRM and add them to Wordpress. <br />Only username and email address will be fetched. <br />Default password of the user will be set as username. <br />Users with existing usernames or email will not be added.', 'Sync_SugarCRM_Users') ?></p>
    <p class="submit">
      <input type="submit" name="sync_sugarcrm_users" value="<?php _e('Sync', 'Sync_SugarCRM_Users') ?>" class="button-primary" />
    </p>
  </form>
</div>
<?php
	}//End function syncUsersToWPPage()
  
  function syncUsersToWP() {
  
    $result   = array('result'=>array(), 'messages'=>array(),);
    $messages = array();
    // validation
    $ret_messages = $this->checkConfigFilled();
    if (!empty($ret_messages)) {
      $result['messages'][] = $ret_messages;
      return $result;
    }
    // init soap client
    $ret_messages = $this->soapInit();
    if (WP_DEBUG == true) {
      $messages       = array_merge($messages, $ret_messages);
    }

    $offset = 0;
    $limit  = Sync_SugarCRM_Users::USERS_LIMIT;
    
    try {
      
      $response = $this->client->__soapCall('get_entries_count',array('session'=>$this->session_id,'module_name'=>'Users','query'=>'', 'deleted'=>0));
      if (isset($response->result_count) && $response->error->number == 0) {
        if (WP_DEBUG == true) {
          $messages[]   = 'SugarCRM Users count: '.$response->result_count;
        }
        $limit = $response->result_count;
      } else {
        if (isset($response->error, $response->error->description)) {
          if (WP_DEBUG == true) {
            $messages[]   = 'SugarCRM Users count: '.$response->error->description;
          }
        } else {
          if (WP_DEBUG == true) {
            $messages[]   = 'SugarCRM Users count: Error';
          }
        }
        $messages[]   = 'No Users';
      }
      
      $response = $this->client->__soapCall('get_entry_list',array('session'=>$this->session_id,'module_name'=>'Users','query'=>'','order_by'=>'users.user_name asc','offset'=>$offset, 'select_fields'=>array('id', 'user_name', 'email1'), 'max_results'=>$limit));
      
      if (WP_DEBUG == true) {
        $messages[]   = 'SugarCRM Fetched Users: '.sizeof($response->entry_list);
      }
      
      $result['result']   = $response->entry_list;
      $result['messages'] = $messages;
      
      $response = $this->client->__soapCall('logout',array('session'=>$session));
      
    } catch (Exception $ex) {
      $result['messages'][] = $ex->getMessage();
    }
    
    return $result;
  }
  
  function getWordpressUsers($param=array()) {
    $args = array('blog_id'=>$GLOBALS['blog_id'], 'orderby'=>'login' );
    $args = $args + $param;

    $blogusers = get_users($args);

    return $blogusers;
  }
  
  function printWordPressUsersSelectForm() {
    $messages = array();
    // validation
    $ret_messages = $this->checkConfigFilled();
    if (!empty($ret_messages)) {
      $messages[] = $ret_messages;
?>    
    <div class="updated"><p><strong><?php _e(implode('<br />', $messages), "Sync_SugarCRM_Users");?></strong></p></div>
<?php	
      return;
    }
    // init soap client
    $ret_messages  = $this->soapInit();
    if (WP_DEBUG == true) {
      $messages       = array_merge($messages, $ret_messages);
    }
    // on form submit, after wordpress users selected
    if (isset($_POST['select_wordpress_users']) && !empty($_POST['wordpress_users'])) {
      $blogusers  = $this->getWordpressUsers(array('include'=>$_POST['wordpress_users']));
      $ret_messages = $this->syncWordpressUsersToSugarCRM($blogusers);
      $messages     = array_merge($messages, $ret_messages);
?>    
    <div class="updated"><p><strong><?php _e(implode('<br />', $messages), "Sync_SugarCRM_Users");?></strong></p></div>
<?php	
    } else {
    // initial form submit
      $blogusers  = $this->getWordpressUsers();

?>
<div class=wrap>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h2><?php echo SK_PLUGIN_NAME; ?> - Sync to SugarCRM</h2>
<p><?php _e('This will create users in SugarCRM for the selected Wordpress users. <br />Only username and email from Wordpress users will be used. <br />Default password of the user will be set as username. <br />Users with existing usernames or email will not be added.', 'Sync_SugarCRM_Users') ?></p>
<table class="form-table">
<tbody>
<tr valign="top">
<th scope="row"><label for="wordpress_users">Wordpress Users</label></th>
<td><select name="wordpress_users[]" id="wordpress_users" class="regular-text" multiple="multiple" style="min-height:150px; min-width:200px"><?php
foreach ($blogusers as $bloguser) {
  echo '<option value="'.$bloguser->ID.'">'.$bloguser->user_login.'</option>';
}
?></select></td>
</tr>
</tbody>
</table>
<p class="submit">
<input type="submit" name="select_wordpress_users" class="button-primary" value="<?php _e('Sync', 'Sync_SugarCRM_Users') ?>" /></p>
</form>
</div>
<?php
    }
  }
  
  function syncWordpressUsersToSugarCRM($blogusers) {
    $messages = array();
    $user_count = 0;
    $ret_messages  = $this->soapInit();
    if (WP_DEBUG == true) {
      $messages       = array_merge($messages, $ret_messages);
    }
    try {
      
      $response = $this->client->__soapCall('get_entries_count',array('session'=>$this->session_id,'module_name'=>'Users','query'=>'', 'deleted'=>0));
      if (isset($response->result_count) && $response->error->number == 0) {
        if (WP_DEBUG == true) {
          $messages[]   = 'SugarCRM Users count: '.$response->result_count;
        }
        $user_count = $response->result_count;
      } else {
        if (isset($response->error, $response->error->description)) {
          if (WP_DEBUG == true) {
            $messages[]   = 'SugarCRM Users count: '.$response->error->description;
          }
        } else {
          if (WP_DEBUG == true) {
            $messages[]   = 'SugarCRM Users count: Error';
          }
        }
        $messages[]   = 'Not synced';
        
        return $messages;
      }
      
      // Fetch SugarCRM Users - START
      $response = $this->client->__soapCall('get_entry_list',array('session'=>$this->session_id,'module_name'=>'Users','query'=>'','order_by'=>'users.user_name asc','offset'=>0, 'select_fields'=>array('id', 'user_name', 'email1'), 'max_results'=>$user_count));
      
      if (WP_DEBUG == true) {
        $messages[]   = 'SugarCRM Fetched Users: '.sizeof($response->entry_list);
      }
      $sugarcrm_users = array();
      foreach ($response->entry_list as $key=>$user_obj) {
        foreach ($user_obj->name_value_list as $user_field) {
          if (in_array($user_field->name, array('user_name', 'email1'))) {
            switch ($user_field->name) {
              case 'user_name':
                $user_name  = $user_field->value;
                break;
              case 'email1':
                $user_email  = $user_field->value;
                break;
            }
          }
        }
        $sugarcrm_users[$user_name] = $user_email;
      }
      // END
      
      $unique_users = array();
      $sugarcrm_users_usernames   = array_keys($sugarcrm_users);
      $sugarcrm_users_useremails  = array_values($sugarcrm_users);
      foreach ($blogusers as $bloguser) {
        if (in_array($bloguser->user_login, $sugarcrm_users_usernames)){
          $messages[]   = "{$bloguser->user_login} | {$bloguser->user_email} | User Exists (existing username)";
        } elseif (in_array($bloguser->user_email, $sugarcrm_users_useremails)) {
          $messages[]   = "{$bloguser->user_login} | {$bloguser->user_email} | User Exists (existing email address)";
        } else {
          $unique_users[] = $bloguser;
        }
      }
      
      $data = array();
      foreach ($unique_users as $bloguser) {
        $data[] = array(
          array('name' => 'user_name',          'value' => $bloguser->user_login ), 
          array('name' => 'user_hash',          'value' => md5($bloguser->user_login) ), 
          array('name' => 'last_name',          'value' => $bloguser->user_login ), 
          array('name' => 'email1',             'value' => $bloguser->user_email ), 
          array('name' => 'assigned_user_id',   'value' => $this->user_id ), 
          array('name' => 'status',             'value' => 'Active' ), 
          array('name' => 'employee_status',    'value' => 'Active' ), 
        );
        $synced_messages[] = "{$bloguser->user_login} | {$bloguser->user_email} | User Created";
      }
      
      if (sizeof($unique_users) > 0) {
        $response = $this->client->__soapCall('set_entries',array('session'=>$this->session_id, 'module_name'=>'Users', $data));
        if ( isset($response->error, $response->error->number) && $response->error->number == 0 ) {
          $messages = array_merge($messages, $synced_messages);
        }
      }
      
      $response = $this->client->__soapCall('logout',array('session'=>$this->session_id));
      
    } catch (Exception $ex) {
      $messages[] = $ex->getMessage();
    }
    
    
    return $messages;
  }
  
  function soapInit() {
    $messages = array();
    if ($this->client !== null) return $messages;
    $devOptions = $this->sync_sugarcrm_users_parameters;
    $user_name  = $devOptions['crm_user_name'];
    $user_password  = $devOptions['crm_user_hash'];
    $options = array(
      "uri" => $devOptions['crm_url'],
      "trace" => true,
    );
    $messages[] = 'URL: '.$devOptions['crm_url'];
    $messages[] = 'User :'.$devOptions['crm_user_name'];
    //$messages[] = 'hash: '.$devOptions['crm_user_hash'];
    try {
      //$client = new SoapClient($options['uri'].'service/v4_1/soap.php?wsdl', $options);
      //$client = new SoapClient($options['uri'].'service/v2/soap.php?wsdl', $options);
      $client = new SoapClient($options['uri'].'soap.php?wsdl', $options);
      $this->client = $client;

      $response = $client->__soapCall('login',array('user_auth'=>array('user_name'=>$user_name,'password'=>$user_password, 'version'=>'.01'), 'application_name'=>'Sync_SugarCRM_Users'));

      $this->session_id = $response->id;
      $messages[]   = 'Session ID: '.$this->session_id;
      
      $response = $client->__soapCall('get_user_id',array('session'=>$this->session_id));
      $this->user_id = $response;
      $messages[]   = 'User ID: '.$response;
      
    } catch (Exception $ex) {
      if (empty($client)) {
        if (WP_DEBUG == true) echo $ex->getMessage();
        else echo 'error initiating soap client';
        exit;
      }
      $messages[] = $ex->getMessage();
    }
    
    return $messages;
  }
  
  function checkConfigFilled () {
    if (!class_exists("SoapClient")) {
      return 'SOAP extension must be enabled in PHP for this plugin to work';
    }
  
    $devOptions = $this->sync_sugarcrm_users_parameters;
    if (empty($devOptions['crm_url'])) {
      return 'SugarCRM url not saved in config page.';
    }
    if (empty($devOptions['crm_user_name'])) {
      return 'SugarCRM username not saved in config page.';
    }
    if (empty($devOptions['crm_user_hash'])) {
      return 'SugarCRM password not saved in config page.';
    }
    
    return '';
  }

  function sync_sugarcrm_user_register($user_id) {
    $messages = array();
    $devOptions = $this->sync_sugarcrm_users_parameters;
    if ($devOptions['crm_auto_create_user'] != 1) {
      return $messages;
    }
    
    $user_info = get_userdata($user_id);
    if (!$user_info) {
      if (WP_DEBUG == true) {
        $messages[] = 'No user with id: '.$user_id;
      }
      return $messages;
    }
    if (WP_DEBUG == true) {
      $messages[] = 'New user created: '.$user_info->user_login;
    }
    
    $ret_messages  = $this->soapInit();
    if (WP_DEBUG == true) {
      $messages       = array_merge($messages, $ret_messages);
    }
    try { 
      // Get count of users from SugarCRM with same username
      $response = $this->client->__soapCall('get_entries_count',array('session'=>$this->session_id,'module_name'=>'Users','query'=>" users.user_name = '{$user_info->user_login}' ", 'deleted'=>0));

      if (WP_DEBUG == true) {
        if ($response->error->number) {
          $messages[] = 'SugarCRM searched user count: '.$response->error->description;
        } else {
          $messages[] = 'SugarCRM searched user count: '.sizeof($response->result_count);
          $messages[] = "User with username {$user_info->user_login} exists in SugarCRM";
        }
      }
      // SOAP request checking if user exists in SugarCRM failed
      if ($response->error->number) {
        return $messages;
      } elseif ($response->result_count > 0) {
        // User already exists in SugarCRM
        return $messages;
      }
      
      // Add user to SugarCRM
      $user_arr = array(
        array('name' => 'user_name'  , 'value' => $user_info->user_login,), 
        array('name' => 'last_name'  , 'value' => $user_info->user_login,), 
        array('name' => 'user_hash'  , 'value' => md5($user_info->user_login),), 
        array('name' => 'email1'     , 'value' => $user_info->user_email,), 
        array('name' => 'assigned_user_id',   'value' => $this->user_id ), 
        array('name' => 'status'          ,   'value' => 'Active' ), 
        array('name' => 'employee_status' ,   'value' => 'Active' ), 
      );
      $response = $this->client->__soapCall('set_entry',array('session'=>$this->session_id,'module_name'=>'Users','name_value_list'=>$user_arr));
      
      if (WP_DEBUG == true) {
        if ($response->error->number) {
          $messages[] =  'SugarCRM user created: error: '.$response->error->description;
        } else {
          $messages[] =  'SugarCRM user created: id: '.$response->id;
        }
      }
    } catch (Exception $ex) {
      if (WP_DEBUG == true) {
        $messages[] = $ex->getMessage();
      }
    }
    
    return $messages;
  }
  
}
}

if (class_exists("Sync_SugarCRM_Users")) {
	$sync_sugarcrm_users = new Sync_SugarCRM_Users();
}

//Initialize the admin panel
if (!function_exists("sync_sugarcrm_users_ap")) {
	function sync_sugarcrm_users_ap() {
		global $sync_sugarcrm_users;
		if (!isset($sync_sugarcrm_users)) {
			return;
		}

    add_menu_page('Sync CRM Users', 'Sync CRM', 10, basename(__FILE__), array(&$sync_sugarcrm_users, 'syncPage'));
    // add_submenu_page( $parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function);
    add_submenu_page(basename(__FILE__), 'Sync to WP', 'Sync to WP', 10, basename(__FILE__).'_to_WP', array(&$sync_sugarcrm_users, 'syncUsersToWPPage'));
    add_submenu_page(basename(__FILE__), 'Sync to SugarCRM', 'Sync to SugarCRM', 10, basename(__FILE__).'_wordpress_sync', array(&$sync_sugarcrm_users, 'printWordPressUsersSelectForm'));
    add_submenu_page(basename(__FILE__), 'SugarCRM', 'SugarCRM', 10, basename(__FILE__).'_view_sugarcrm', array(&$sync_sugarcrm_users, 'printViewSugarCRM'));
    add_submenu_page(basename(__FILE__), 'Config', 'Config', 10, basename(__FILE__).'_config', array(&$sync_sugarcrm_users, 'printConfigPage'));
	}
}

//Actions and Filters	
if (isset($sync_sugarcrm_users)) {
	//Actions
	add_action('admin_menu', 'sync_sugarcrm_users_ap');
	add_action('user_register', array(&$sync_sugarcrm_users, 'sync_sugarcrm_user_register') );
	//add_action('activate_sync-sugarcrm-users.php/sync-sugarcrm-users.php',  array(&$sync_sugarcrm_users, 'init'));
  register_activation_hook( __FILE__, array(&$sync_sugarcrm_users, 'init') );
  register_deactivation_hook( __FILE__, array(&$sync_sugarcrm_users, 'deactivate') );
}
